#include <windows.h>
#include "filter.h"

#define TRACK_N 0
#define CHECK_N 1
TCHAR*  check_name[] = {""};
int     check_default[] = {1};

FILTER_DLL filter = {
    FILTER_FLAG_EX_INFORMATION, //    tB^̃tO
    0,0,                        //    ݒEChẼTCY (FILTER_FLAG_WINDOW_SIZEĂ鎞ɗL)
    "BT.709 vr[",            //    tB^̖O
    TRACK_N,                    //    gbNo[̐ (0Ȃ疼OlNULLł悢)
    NULL,                       //    gbNo[̖OSւ̃|C^
    NULL,                       //    gbNo[̏lSւ̃|C^
    NULL,NULL,                  //    gbNo[̐l̉ (NULLȂS0`256)
    CHECK_N,                    //    `FbN{bNX̐ (0Ȃ疼OlNULLł悢)
    check_name,                 //    `FbN{bNX̖OSւ̃|C^
    check_default,              //    `FbN{bNX̏lSւ̃|C^
    func_proc,                  //    tB^֐ւ̃|C^ (NULLȂĂ΂܂)
    NULL,                       //    JnɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
    NULL,                       //    IɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
    NULL,                       //    ݒ肪ύXꂽƂɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
    NULL,                       //    ݒEBhEɃEBhEbZ[WɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
    NULL,NULL,                  //    VXeŎg܂̂ŎgpȂł
    NULL,                       //  gf[^̈ւ̃|C^ (FILTER_FLAG_EX_DATAĂ鎞ɗL)
    NULL,                       //  gf[^TCY (FILTER_FLAG_EX_DATAĂ鎞ɗL)
    "BT.709 vr[ Ver.110810",
    //  tB^ւ̃|C^ (FILTER_FLAG_EX_INFORMATIONĂ鎞ɗL)
    NULL,                       //    Z[uJn钼OɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
    NULL,                       //    Z[uIOɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
};

//---------------------------------------------------------------------
//      tB^\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTable( void )
{
    return &filter;
}
const __declspec(align(16)) short i128_pw_3361_6427[8] =   { 3361,  6427, 3361,  6427, 3361,  6427, 3361,  6427};
const __declspec(align(16)) short i128_pw_32435_m3626[8] = {32435, -3626,32435, -3626,32435, -3626,32435, -3626};
const __declspec(align(16)) short i128_pw_m2374_32224[8] = {-2374, 32224,-2374, 32224,-2374, 32224,-2374, 32224};

void bt709_to_bt601(int thread_id, int thread_num, void *param1, void *param2)
{
    FILTER_PROC_INFO* fpip = (FILTER_PROC_INFO*)param2;
    int w = fpip->w;
    int h = fpip->h;
    int y_start = thread_id * h / thread_num;
    int y_end = (thread_id+1) * h / thread_num;
    int yloopcount = y_end - y_start;
    int xloopcount = (w+7) / 8;
    int step = fpip->max_w * 6 - xloopcount * 48;
    PIXEL_YC* src = fpip->ycp_edit + y_start * (fpip->max_w);
    __asm
    {
        movdqa              xmm5, i128_pw_3361_6427
        movdqa              xmm6, i128_pw_32435_m3626
        movdqa              xmm7, i128_pw_m2374_32224
        mov                 edx, src
        mov                 eax, yloopcount
    yloop:
        mov                 ecx, xloopcount
    align 16
    xloop:
        movdqa              xmm0, [edx]
        movdqa              xmm1, [edx+16]
        movdqa              xmm2, [edx+32]
        
        punpcklqdq          xmm3, xmm0
        psrldq              xmm0, 8
        punpcklqdq          xmm4, xmm1
        punpckhwd           xmm3, xmm1
        punpcklwd           xmm0, xmm2
        punpckhwd           xmm4, xmm2
        
        punpcklqdq          xmm1, xmm3
        psrldq              xmm3, 8
        punpcklqdq          xmm2, xmm0
        punpckhdq           xmm1, xmm0
        punpckldq           xmm3, xmm4
        punpckhdq           xmm2, xmm4
        
        punpcklqdq          xmm0, xmm1
        psrldq              xmm1, 8
        punpcklqdq          xmm4, xmm3
        punpckhqdq          xmm0, xmm3
        punpcklqdq          xmm1, xmm2
        punpckhqdq          xmm4, xmm2
        
        movdqa              xmm2, xmm1
        punpcklwd           xmm1, xmm4
        punpckhwd           xmm2, xmm4
        movdqa              xmm3, xmm1
        movdqa              xmm4, xmm2
        pmaddwd             xmm1, xmm5
        pmaddwd             xmm2, xmm5
        psrad               xmm1, 15
        psrad               xmm2, 15
        packssdw            xmm1, xmm2
        paddsw              xmm0, xmm1
        movdqa              xmm1, xmm3
        movdqa              xmm2, xmm4
        pmaddwd             xmm3, xmm6
        pmaddwd             xmm4, xmm6
        pmaddwd             xmm1, xmm7
        pmaddwd             xmm2, xmm7
        psrad               xmm3, 15
        psrad               xmm4, 15
        psrad               xmm1, 15
        psrad               xmm2, 15
        packssdw            xmm3, xmm4
        packssdw            xmm1, xmm2
        
        pshufd              xmm2, xmm0, 0x0E
        punpcklwd           xmm0, xmm3
        punpckhwd           xmm3, xmm1
        punpcklwd           xmm1, xmm2
        
        pshufd              xmm2, xmm0, 0x0E
        punpckldq           xmm0, xmm1
        punpckhdq           xmm1, xmm3
        punpckldq           xmm3, xmm2
        
        pshufd              xmm2, xmm0, 0x0E
        punpcklqdq          xmm0, xmm3
        punpckhqdq          xmm3, xmm1
        punpcklqdq          xmm1, xmm2
        
        movdqa              [edx], xmm0
        movdqa              [edx+16], xmm1
        movdqa              [edx+32], xmm3
        add                 edx, 48
        sub                 ecx, 1
        jnz                 xloop
        
        add                 edx, step
        sub                 eax, 1
        jnz                 yloop
    }
}

//---------------------------------------------------------------------
//      tB^֐
//---------------------------------------------------------------------
BOOL func_proc( FILTER *fp,FILTER_PROC_INFO *fpip )
{
    if (fp->exfunc->is_saving(fpip->editp) == FALSE)
    {
        if(fp->check[0] == 0 || fpip->org_h >= 720)
        {
            fp->exfunc->exec_multi_thread_func(bt709_to_bt601, NULL, fpip);
        }
    }
    return TRUE;
}